/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bmepsgui;

import java.io.File;
import java.awt.SplashScreen;
import javax.swing.SwingUtilities;
import dirk_krause.jtools.GuiController;

class CreateGUI implements Runnable {
    public static String applicationName = "BmepsGUI";
    protected String wd = null;
    public CreateGUI(String s) { wd = s; }
    public void run() {
        GuiController guic = new GuiController(applicationName, true);
        guic.initialize();
        BmepsController bc = new BmepsController();
        bc.init(); if(wd != null) { bc.setString(0, wd); }
        createAndShowGui(guic, bc);
    }
    void createAndShowGui(GuiController gc, BmepsController bc) {
        BmepsMainWindow mw = new BmepsMainWindow(gc, bc);
        mw.retrieveSettings();
	try {
	  SplashScreen sso = SplashScreen.getSplashScreen();
	  if(sso != null) { sso.close(); }
	} catch(Exception e) {}
        mw.setVisible(true);
    }
}



/**
 *
 * @author krause
 */
public class BmepsMainProgram {
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String wd = null;
	if(args.length > 0) {
	  try {
	    File f = new File(args[0]);
	    if(f.exists()) {
	      if(f.isDirectory()) {
	        wd = args[0];
	      }
	    }
	  } catch(Exception exc) {}
	}
        // TODO code application logic here
        SwingUtilities.invokeLater(new CreateGUI(wd));
    }
    
}



// vim: set ai sw=2 :
// project bmeps
// @(#)BmepsMainProgram.java 1.6 10/28/09

