/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bmepsgui;
import java.awt.event.WindowEvent;
// jlayout.import.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.ImageIcon;
import javax.swing.WindowConstants;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.import.end

import java.io.File;
import java.io.IOException;
import java.util.Enumeration;
import java.util.HashSet;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.Component;
import javax.swing.Box;
import javax.swing.JFileChooser;
import javax.swing.SwingUtilities;
import dirk_krause.jtools.GuiController;
import dirk_krause.jtools.ApplicationFrame;
import dirk_krause.jtools.StringTool;
import dirk_krause.jtools.GuiDialog;
import dirk_krause.jtools.DirectoryFilter;
import dirk_krause.jtools.SizeTracker;
import dirk_krause.jtools.LogWindow;
import dirk_krause.jtools.LogContents;
import dirk_krause.jtools.LogContentsForCommand;
import dirk_krause.jtools.HelpWindow;
import dirk_krause.jtools.SizeTracker;
import dirk_krause.jtools.ComponentPositioner;
import dirk_krause.jtools.OneDirectoryDropTransferHandler;
import java.net.URI;
import java.net.URL;

/**
 *
 * @author krause
 */
public class BmepsMainWindow
    extends ApplicationFrame
    implements ActionListener
{
  class DropHandler extends OneDirectoryDropTransferHandler {
    @Override
    protected boolean processFilename(String s) {
      boolean back = false;
      File f = new File(s);
      if(f.isDirectory()) {
        bc.setString(0, s); back = true;
	SwingUtilities.invokeLater(new DirectoryChanger(s));
      }
      return back;
    }
  }
  class DirectoryChanger implements Runnable {
    String newDirectory;
    public DirectoryChanger(String s) {
      newDirectory = s;
    }
    public void run() {
      setNewDirectoryName(newDirectory);
    }
  }
  /**
   * License terms.
   */
  public static final String licenseTerms =
    "<html>\n"
    + "<head>\n"
    + "</head>\n"
    + "<body>\n"
    + "<p>This is BmepsGUI, version 1.2.0</p>"
    + "<p>\n"
    + "Copyright (c) 2008, Dirk Krause<br>\n"
    + "All rights reserved.\n"
    + "</p>\n"
    + "<p>\n"
    + "Redistribution and use in source and binary forms,\n"
    + "with or without modification, are permitted provided\n"
    + "that the following conditions are met:\n"
    + "<ul>\n"
    + "<li>Redistributions of source code must retain the above\n"
    + "copyright notice, this list of conditions and the\n"
    + "following disclaimer.</li>\n"
    + "<li>Redistributions in binary form must reproduce the above \n"
    + "opyright notice, this list of conditions and the following\n"
    + "disclaimer in the documentation and/or other materials\n"
    + "provided with the distribution.</li>\n"
    + "<li>Neither the name of the Dirk Krause nor the names of\n"
    + "its contributors may be used to endorse or promote\n"
    + "products derived from this software without specific\n"
    + "prior written permission.</li>\n"
    + "</ul>\n"
    + "THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND\n"
    + "CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES,\n"
    + "INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\n"
    + "MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n"
    + "DISCLAIMED.<br>\n"
    + "IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE\n"
    + "LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,\n"
    + "EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n"
    + "LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n"
    + "LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\n"
    + "HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\n"
    + "CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE\n"
    + "OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
    + "SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH\n"
    + "DAMAGE.\n"
    + "</p>\n"
    + "</body>\n"
    + "</html>\n";


  protected final String helpFilename = "index.html";
  protected Color cRed = null;
  protected Color cGreen = null;
  protected GuiController guic;
  protected BmepsController bc;
  protected int border;
  protected boolean i_am_running = false;
  protected SizeTracker stDirectory = null;
  protected GuiDialog guid = null;
  protected BmepsOptionsDialog bod = null;
  protected LogWindow lwn = null;
  protected HelpWindow hwn = null;
  protected SizeTracker t1 = null;
  protected SizeTracker t2 = null;
  protected DropHandler dh = null;

// jlayout.variables.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	JButton bDirectory = null;
	JButton bExit = null;
	JButton bOptions = null;
	JButton bRun = null;
	JToolBar jtButtons = null;
	JLabel lBmepsIcon = null;
	JLabel lCurrentDirectory = null;
	JLabel lCurrentFile = null;
	JLabel lDirectory = null;
	JLabel lStatus = null;
	JMenu mFile = null;
	JMenuItem mFileDirectory = null;
	JMenuItem mFileExit = null;
	JMenuItem mFileOptions = null;
	JMenuItem mFileRun = null;
	JMenuItem mGUI = null;
	JMenu mHelp = null;
	JMenuItem mLocalHelp = null;
	JMenu mOptions = null;
	JMenuItem mVersion = null;
	JMenuItem mWeb = null;
	JMenuBar mb = null;
	JPanel pa = null;
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.variables.end

// jlayout.setup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Find an image icon.
	 *
	 * @param n
	 * The name of the image icon file.
	 *
	 * @return
	 * The image icon.
	 */
	protected ImageIcon jLayoutImageIconFromName(String n)
	{
	  ImageIcon back = null;
	  try {
	    back = new ImageIcon(getClass().getResource(n));
	  }
	  catch(NullPointerException e) {
	    back = new ImageIcon(n);
	  }
	  return back;
	}
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bDirectory 90
	  bDirectory = new JButton(jLayoutImageIconFromName(BGS.fn[0]));
	  bDirectory.setActionCommand(BGS.ac[0]);
	  bDirectory.setToolTipText(BGS.lt[0]);
	  bDirectory.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[0]
	  );
	  // bExit 93
	  bExit = new JButton(jLayoutImageIconFromName(BGS.fn[3]));
	  bExit.setActionCommand(BGS.ac[3]);
	  bExit.setToolTipText(BGS.lt[3]);
	  bExit.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[3]
	  );
	  // bOptions 91
	  bOptions = new JButton(jLayoutImageIconFromName(BGS.fn[1]));
	  bOptions.setActionCommand(BGS.ac[1]);
	  bOptions.setToolTipText(BGS.lt[1]);
	  bOptions.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[1]
	  );
	  // bRun 92
	  bRun = new JButton(jLayoutImageIconFromName(BGS.fn[2]));
	  bRun.setActionCommand(BGS.ac[2]);
	  bRun.setToolTipText(BGS.lt[2]);
	  bRun.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[2]
	  );
	  // jtButtons 12
	  jtButtons = new JToolBar();
	  {
	    jtButtons.add(bDirectory);
	    jtButtons.add(bOptions);
	    jtButtons.add(bRun);
	    jtButtons.add(bExit);
	  }
	  // lBmepsIcon 82
	  lBmepsIcon = new JLabel(jLayoutImageIconFromName(BGS.fn[4]));
	  // lCurrentDirectory 84
	  lCurrentDirectory = new JLabel(BGS.lt[10]);
	  // lCurrentFile 86
	  lCurrentFile = new JLabel(BGS.lt[9]);
	  // lDirectory 83
	  lDirectory = new JLabel(BGS.lt[6]);
	  // lStatus 85
	  lStatus = new JLabel(BGS.lt[7]);
	  // mFileDirectory 23
	  mFileDirectory = new JMenuItem(BGS.ac[0]);
	  mFileDirectory.setToolTipText(BGS.lt[0]);
	  mFileDirectory.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[0]
	  );
	  // mFileExit 26
	  mFileExit = new JMenuItem(BGS.ac[3]);
	  mFileExit.setToolTipText(BGS.lt[3]);
	  mFileExit.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[3]
	  );
	  // mFileOptions 24
	  mFileOptions = new JMenuItem(BGS.ac[1]);
	  mFileOptions.setToolTipText(BGS.lt[1]);
	  mFileOptions.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[1]
	  );
	  // mFileRun 25
	  mFileRun = new JMenuItem(BGS.ac[2]);
	  mFileRun.setToolTipText(BGS.lt[2]);
	  mFileRun.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[2]
	  );
	  // mGUI 51
	  mGUI = new JMenuItem(BGS.ac[4]);
	  mGUI.setToolTipText(BGS.lt[5]);
	  mGUI.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[5]
	  );
	  // mLocalHelp 62
	  mLocalHelp = new JMenuItem(BGS.ac[17]);
	  mLocalHelp.setToolTipText(BGS.lt[102]);
	  mLocalHelp.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[102]
	  );
	  // mOptions 17
	  mOptions = new JMenu();
	  mOptions.setText(BGS.ac[6]);
	  mOptions.setToolTipText(BGS.lt[4]);
	  mOptions.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[4]
	  );
	  {
	    mOptions.add(mGUI);
	  }
	  // mVersion 63
	  mVersion = new JMenuItem(BGS.ac[18]);
	  mVersion.setToolTipText(BGS.lt[103]);
	  mVersion.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[103]
	  );
	  // mWeb 61
	  mWeb = new JMenuItem(BGS.ac[16]);
	  mWeb.setToolTipText(BGS.lt[101]);
	  mWeb.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[101]
	  );
	  // pa 13
	  pa = new JPanel();
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pa.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, false);
	    gbc = jLayoutGbc(
	      4, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    dp = jLayoutCreateDistancePanel(border, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pa.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lBmepsIcon, gbc);
	    pa.add(lBmepsIcon);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lDirectory, gbc);
	    pa.add(lDirectory);
	    gbc = jLayoutGbc(
	      3, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lCurrentDirectory, gbc);
	    pa.add(lCurrentDirectory);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lStatus, gbc);
	    pa.add(lStatus);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lCurrentFile, gbc);
	    pa.add(lCurrentFile);
	  }
	  // mFile 16
	  mFile = new JMenu();
	  mFile.setText(BGS.ac[5]);
	  {
	    mFile.add(mFileDirectory);
	    mFile.add(mFileOptions);
	    mFile.add(mFileRun);
	    mFile.add(mFileExit);
	  }
	  // mHelp 19
	  mHelp = new JMenu();
	  mHelp.setText(BGS.ac[15]);
	  mHelp.setToolTipText(BGS.lt[100]);
	  mHelp.getAccessibleContext().setAccessibleDescription(
	    BGS.lt[100]
	  );
	  {
	    mHelp.add(mWeb);
	    mHelp.add(mLocalHelp);
	    mHelp.add(mVersion);
	  }
	  // mb 10
	  mb = new JMenuBar();
	  {
	    mb.add(mFile);
	    mb.add(mOptions);
	    mb.add(Box.createHorizontalGlue());
	    mb.add(mHelp);
	  }
	  // MAIN 0
	  setTitle(BGS.wt[0]);
	  setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	  {
	    setJMenuBar(mb);
	    Container cp = null;
	    cp = getContentPane();
	    cp.add(jtButtons, BorderLayout.PAGE_START);
	    cp.add(pa, BorderLayout.CENTER);
	  }
	  bDirectory.addActionListener(this);
	  bExit.addActionListener(this);
	  bOptions.addActionListener(this);
	  bRun.addActionListener(this);
	  lBmepsIcon.setTransferHandler(dh);
	  lCurrentDirectory.setTransferHandler(dh);
	  lCurrentFile.setTransferHandler(dh);
	  lDirectory.setTransferHandler(dh);
	  lStatus.setTransferHandler(dh);
	  mFileDirectory.addActionListener(this);
	  mFileExit.addActionListener(this);
	  mFileOptions.addActionListener(this);
	  mFileRun.addActionListener(this);
	  mGUI.addActionListener(this);
	  mLocalHelp.addActionListener(this);
	  mVersion.addActionListener(this);
	  mWeb.addActionListener(this);
	  pa.setTransferHandler(dh);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.setup.end

// jlayout.cleanup.begin
// <editor-fold defaultstate="collapsed" desc="jlayout generated code">
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bDirectory.removeActionListener(this);
	  bExit.removeActionListener(this);
	  bOptions.removeActionListener(this);
	  bRun.removeActionListener(this);
	  mFileDirectory.removeActionListener(this);
	  mFileExit.removeActionListener(this);
	  mFileOptions.removeActionListener(this);
	  mFileRun.removeActionListener(this);
	  mGUI.removeActionListener(this);
	  mLocalHelp.removeActionListener(this);
	  mVersion.removeActionListener(this);
	  mWeb.removeActionListener(this);
	}
// END OF JLAYOUT SECTION
// </editor-fold>
// jlayout.cleanup.end



  /**
   * Create abbreviated directory name.
   *
   * @param s
   * The full directory name.
   *
   * @return
   * The abbreviated directory name.
   */
  public String getShortDirectoryName(String s) {
    String back = s;
    int i = s.lastIndexOf(File.separator);
    if(i >= 0) {
      i += File.separator.length();
      StringBuilder sb = new StringBuilder();
      sb.append("...");
      sb.append(File.separator);
      sb.append(s.substring(i));
      back = sb.toString();
    }
    return back;
  }



  /**
   * Create the main window
   *
   * @param gc
   * The GUI controller.
   *
   * @param b
   * The bmeps controller.
   */
  public BmepsMainWindow(GuiController gc, BmepsController b) {
    super("BmepsGUI", gc);
    guic = gc;
    bc = b;
    border = guic.getBorder();
    cRed = new Color(127, 0, 0);
    cGreen = new Color(0, 127, 0);
    dh = new DropHandler();
    jLayoutSetup();
    lStatus.setForeground(cGreen);
    lCurrentDirectory.setText(getShortDirectoryName(bc.getString(0)));
    lCurrentDirectory.setToolTipText(bc.getString(0));
    stDirectory = new SizeTracker();
    stDirectory.mustPackAgain(lCurrentDirectory);
    t1 = new SizeTracker();
    t2 = new SizeTracker();
    t1.mustPackAgain(lStatus);
    t2.mustPackAgain(lCurrentFile);
    pack();
    restorePosition();
  }



  protected synchronized LogWindow getLogWindow() {
      return lwn;
  }



  protected synchronized void setLogWindow(LogWindow l) {
      lwn = l;
  }



  protected LogWindow useLogWindow() {
    LogWindow back = getLogWindow();
    if(back == null) {
        back = new LogWindow(this, guic);
        back.pack();
        setLogWindow(back);
        back.chooseNonmodalPosition(this);
    }
    return back;
  }



  protected synchronized HelpWindow getHelpWindow() {
    return hwn;
  }



  protected synchronized void setHelpWindow(HelpWindow h) {
    hwn = h;
  }



  protected HelpWindow useHelpWindow() {
    HelpWindow back = getHelpWindow();
    if(back == null) {
      back = new HelpWindow(this, guic);
      setHelpWindow(back);
      back.pack();
      back.chooseNonmodalPosition(this);
    }
    return back;
  }



  /**
   * Clean up after the window is closed.
   *
   * @param isLast
   * Flag to indicate whether or not this is the last window
   * of it's type.
   */
  public void cleanup(boolean isLast) {
    if(isLast) {
      bc.save();
    }
    GuiDialog xguid = getGuid();
    if(xguid != null) {
      setGuid(null); xguid.cleanup(); xguid.dispose();
    }
    LogWindow logwin = getLogWindow();
    if(logwin != null) {
        setLogWindow(null); logwin.cleanup(); logwin.dispose();
    }
    jLayoutCleanup();
    dh = null;
    if(isLast) {

    }
    xguid = null;
    guic = null;
    bc = null;
    stDirectory = null;
  }



  /**
   * Check whether or not the background thread is running.
   *
   * @return
   * Flag to indicate whether a thread is running.
   */
  protected synchronized boolean getIsRunning() {
    boolean back = i_am_running;
    return back;
  }



  /**
   * Set flag to indicate background thread is running.
   *
   * @param b
   * New flag value.
   */
  protected synchronized void setIsRunning(boolean b) {
    i_am_running = b;
  }



  /**
   * Retrieve settings.
   */
  public void retrieveSettings() {

  }



  /**
   * Get GUI dialog box.
   *
   * @return
   * The GUI dialog box.
   */
  private synchronized GuiDialog getGuid() { return guid; }



  /**
   * Set GUI dialog box.
   *
   * @param d
   * The GUI dialog box.
   */
  private synchronized void setGuid(GuiDialog d) { guid = d; }



  /**
   * Get GUI dialog box, create if necessary.
   *
   * @return
   * The GUI dialog box.
   */
  private GuiDialog useGuid() {
    GuiDialog back = getGuid();
    if(back == null) {
      back = new GuiDialog(this, guic); setGuid(back);
      back.chooseModalPosition(this);
    }
    return back;
  }



  /**
   * Get bmeps options dialog box.
   *
   * @return
   * The bmeps options dialog box.
   */
  private synchronized BmepsOptionsDialog getBod() { return bod; }



  /**
   * Set the bmeps options dialog box variable.
   *
   * @param b
   * The bmeps options dialog box.
   */
  private synchronized void setBod(BmepsOptionsDialog b) { bod = b; }



  /**
   * Get the bmeps options dialog box, create if necessary.
   *
   * @return
   * The bmeps options dialog box.
   */
  private BmepsOptionsDialog useBod() {
    BmepsOptionsDialog back = getBod();
    if(back == null) {
      back = new BmepsOptionsDialog(this, guic, bc);
      setBod(back);
      back.chooseModalPosition(this);
      back.set_to_defaults();
    }
    return back;
  }



  private boolean filenameEndsWith(String fn, String su, boolean cs) {
    boolean back = false;
    if(cs) {
      back = fn.endsWith(su);
    } else {
      int lfn = fn.length(); int lsu = su.length();
      if(lfn > lsu) {
        back = fn.substring(lfn - lsu).equalsIgnoreCase(su);
      }
    }
    return back;
  }



  private String[] createListOfInputFiles(BmepsController mybc) {
    int i;
    boolean isGoodInputType = false;
    boolean isCaseSensitive = mybc.bv[64];
    String[] back = null;
    String currentDirectory = mybc.sv[0];
    File fCurrentDirectory = new File(currentDirectory);
    if(fCurrentDirectory.exists()) {
      if(fCurrentDirectory.isDirectory()) {
        String[] allContents = fCurrentDirectory.list();
        HashSet<String> hs = new HashSet<String>();
        for(i = 0; i < allContents.length; i++) {
          String fn = allContents[i];
          isGoodInputType = false;
          if(mybc.bv[4]) {	// PNG
	    if(!isGoodInputType) {
	      isGoodInputType = filenameEndsWith(
	        fn, BGS.fileSuffixes[0], isCaseSensitive
	      );
	    }
          }
          if(mybc.bv[5]) {	// JPEG
	    if(!isGoodInputType) {
	      isGoodInputType = filenameEndsWith(
	        fn, BGS.fileSuffixes[1], isCaseSensitive
	      );
	    }
	    if(!isGoodInputType) {
	      isGoodInputType = filenameEndsWith(
	        fn, BGS.fileSuffixes[2], isCaseSensitive
	      );
	    }
          }
          if(mybc.bv[6]) {	// NetPBM
	    if(!isGoodInputType) {
	      isGoodInputType = filenameEndsWith(
	        fn, BGS.fileSuffixes[3], isCaseSensitive
	      );
	    }
	    if(!isGoodInputType) {
	      isGoodInputType = filenameEndsWith(
	        fn, BGS.fileSuffixes[4], isCaseSensitive
	      );
	    }
	    if(!isGoodInputType) {
	      isGoodInputType = filenameEndsWith(
	        fn, BGS.fileSuffixes[5], isCaseSensitive
	      );
	    }
          }
          if(mybc.bv[7]) {	// TIFF
	    if(!isGoodInputType) {
	      isGoodInputType = filenameEndsWith(
	        fn, BGS.fileSuffixes[6], isCaseSensitive
	      );
	    }
	    if(!isGoodInputType) {
	      isGoodInputType = filenameEndsWith(
	        fn, BGS.fileSuffixes[7], isCaseSensitive
	      );
	    }
          }
          if(isGoodInputType) {
            hs.add(fn);
          }
        }
        Object[] objarray = hs.toArray();
        back = new String[objarray.length];
        for(i = 0; i < objarray.length; i++) {
          back[i] = (String)(objarray[i]);
        }
      }
    }
    return back;
  }



  private String createOutputFileName(
    String ifn, String os, BmepsController mybc
  )
  {
    String back = null;
    int i;
    for(i = 0; i < BGS.fileSuffixes.length; i++) {
      if(filenameEndsWith(ifn, BGS.fileSuffixes[i], mybc.bv[64])) {
        int l1 = ifn.length();
	int l2 = BGS.fileSuffixes[i].length();
	String s = ifn.substring(0, (l1 - l2));
	StringBuilder sb = new StringBuilder();
	sb.append(s); sb.append(os);
	back = new String(sb);
        i = BGS.fileSuffixes.length;
      }
    }
    return back;
  }



  /**
   * Do the real work.
   * This method is invoked from the background thread.
   */
  private void runBmepsInThread() {
    int i, j;
    LogWindow l = null;
    boolean mustShowLogWindow = false;
    boolean mustRunForThisFile = false;
    boolean anyCommandExecuted = false;
    String[] listOfSourceFiles = null;
    // build list of sources files
    SwingUtilities.invokeLater(
      new SetStateRunning2(BGS.lt[8], BGS.lt[93], this)
    );
    BmepsController mybc = new BmepsController();
    mybc.cloneFrom(bc);
    String options = mybc.createOptionsString();
    // System.out.println(options);
    listOfSourceFiles = createListOfInputFiles(mybc);
    if(listOfSourceFiles != null) {
      if(listOfSourceFiles.length > 0) {
        l = useLogWindow();
        LogContentsForCommand lcfc = new LogContentsForCommand();
	for(i = 0; i < listOfSourceFiles.length; i++) {
	  String inputFileName = listOfSourceFiles[i];
	  String outputSuffix = mybc.getOutputSuffix();
	  String outputFileName = createOutputFileName(
	    inputFileName, outputSuffix, mybc
	  );
	  // System.out.println(inputFileName + " " + outputFileName);
	  if(outputFileName != null) {
            String fullInputName; String fullOutputName;
	    {
	      StringBuilder sb = new StringBuilder();
	      sb.append(mybc.sv[0]);
	      sb.append(File.separator);
	      sb.append(inputFileName);
	      fullInputName = new String(sb);
	      sb = new StringBuilder();
	      sb.append(mybc.sv[0]);
	      sb.append(File.separator);
	      sb.append(outputFileName);
	      fullOutputName = new String(sb);
	    }
            mustRunForThisFile = true;
	    if(mybc.bv[65]) {
	      File fs = new File(fullInputName);
	      File fd = new File(fullOutputName);
              if(fd.lastModified() > fs.lastModified()) {
                mustRunForThisFile = false;
              }
	    }
	    if(mustRunForThisFile) {
              SwingUtilities.invokeLater(
                new SetStateRunning2(BGS.lt[8], inputFileName, this)
              );
              anyCommandExecuted = true;
              lcfc.newCommand();
              lcfc.addArgv(BmepsController.cmdToConvert[0]);
              lcfc.addArgv(options);
              lcfc.addArgv(fullInputName);
              lcfc.addArgv(fullOutputName);
              for(j = 1; j < BmepsController.cmdToConvert.length; j++) {
                lcfc.addArgv(BmepsController.cmdToConvert[j]);
              }
              lcfc.run();
              if(!lcfc.getSuccess()) {
                mustShowLogWindow = true;
              }
	    }
	  }
	}
        if(anyCommandExecuted) {
          if(mybc.bv[62]) {
            mustShowLogWindow = true;
            lcfc.setShowAlways(true);
          } else {
            String textInLcfc = lcfc.getContents();
            if(textInLcfc.contains("\\pdfpageattr")) {
              mustShowLogWindow = true;
              lcfc.setShowAlways(true);
            }
          }
	  if(mustShowLogWindow) {
            l.showTextIfNecessary(lcfc);
	  }
        }
      }
    }
    // run bmeps for each source file to process
    // if necessary create and show the log window
    // finally note that we are not longer running
    setIsRunning(false);
    // set state back to ready
    SwingUtilities.invokeLater(new SetStateReady());
  }


  /**
   * Enable/disable GUI while background thread is running.
   * @param b
   *
   * Enable or disable flag.
   */
  private void enableGui(boolean b) {
    bDirectory.setEnabled(b);
    bOptions.setEnabled(b);
    bRun.setEnabled(b);
    bExit.setEnabled(b);
    mFileDirectory.setEnabled(b);
    mFileOptions.setEnabled(b);
    mFileRun.setEnabled(b);
    mFileExit.setEnabled(b);
    dh.setEnabled(b);
  }


  /**
   * Run bmeps for the current directory.
   */
  protected void runBmeps() {
    Thread thr = new Thread(new ProgramRunner());
    setIsRunning(true);
    enableGui(false);
    thr.start();
  }



  /**
   * show options dialog.
   */
  protected void setOptions() {
    BmepsOptionsDialog b;
    b = useBod();
    b.controller_to_dialog();
    b.setModal(true);
    b.setVisible(true);
  }



  private void setNewDirectoryName(String s) {
    lCurrentDirectory.setText(getShortDirectoryName(s));
    lCurrentDirectory.setToolTipText(s);
    if(stDirectory.mustPackAgain(lCurrentDirectory)) {
      pack(); ComponentPositioner.correctPosition(this);
    }
    repaint();
  }



  /**
   * choose new current directory.
   */
  protected void chooseDirectory() {
    String workingDirectory;
        JFileChooser c = new JFileChooser(bc.getString(0));
        c.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        c.setFileFilter(new DirectoryFilter());
        int result = c.showOpenDialog(this);
        if(result == JFileChooser.APPROVE_OPTION) {
            workingDirectory = c.getSelectedFile().getAbsolutePath();
	    bc.setString(0, workingDirectory);
	    setNewDirectoryName(workingDirectory);
        }
  }



  /**
   * React on a pushed button...
   *
   * @param e
   * The action event.
   */
  public void actionPerformed(ActionEvent e) {
    switch(StringTool.getArrayIndex(BGS.ac,e.getActionCommand())) {
      case 0: {   // Directory
        if(!getIsRunning()) {
          chooseDirectory();
        }
      } break;
      case 1: {   // Options
        if(!getIsRunning()) {
          setOptions();
        }
      } break;
      case 2: {   // Run
        if(!getIsRunning()) {
          runBmeps();
        }
      } break;
      case 3: {   // Exit
        if(!getIsRunning()) {
        processWindowEvent(
            new WindowEvent(this, WindowEvent.WINDOW_CLOSING)
        );
        }
      } break;
      case 4: {   // GUI
        if(!getIsRunning()) {
          GuiDialog d = useGuid();
          d.controllerToDialog();
          d.setModal(true);
          d.setVisible(true);
        }
      } break;
      case 16: {
        try {
          Desktop.getDesktop().browse(new URI(BGS.projectUri));
	} catch(Exception exc) {}
      } break;
      case 17: { // local help
        URL helpUrl = null;
        HelpWindow lwn = useHelpWindow();
	lwn.setPurpose(1);
	lwn.setContentType(0);
	lwn.setTitle(BGS.lt[105]);
        helpUrl = BmepsMainWindow.class.getResource(helpFilename);
        if(helpUrl != null) {
          try {
            getHelpWindow().setPage(helpUrl);
          }
          catch(IOException ioe) {
            getHelpWindow().setText(LogWindow.theTexts[1]);
          }
        } else {
        }
	if(lwn.isVisible()) {
	  lwn.repaint();
	} else {
	  lwn.setVisible(true);
	}
      } break;
      case 18: { // version
        HelpWindow lwn = useHelpWindow();
	lwn.setPurpose(2);
	lwn.setContentType(1);
	lwn.setTitle(BGS.lt[106]);
	lwn.setText(licenseTerms);
	if(lwn.isVisible()) {
	  lwn.repaint();
	} else {
	  lwn.setVisible(true);
	}
      } break;
    }
  }



  /**
   * Runnable for background thread.
   */
  class ProgramRunner implements Runnable {

    /**
     * Constructor.
     */
    public ProgramRunner() {
    }

    /**
     * Implementation of Runnable.
     */
    public void run() {
      runBmepsInThread();
    }

  }



  /**
   * Runnable to set state back to ready.
   */
  class SetStateReady implements Runnable {

    /**
     * Constructor.
     */
    public SetStateReady() {
    }

    /**
     * Implementation of Runnable.
     */
    public void run() {
      lStatus.setForeground(cGreen);
      lStatus.setText(BGS.lt[7]);
      lCurrentFile.setText(BGS.lt[9]);
      enableGui(true);
      repaint();
    }

  }



  /**
   * Runnable to set two status fields
   * (lStatus and lCurrentFile) to new texts.
   */
  class SetStateRunning2 implements Runnable {

    /** text for lStatus */
    String text1;

    /** text for lCurrentFile */
    String text2;

    /** The main window */
    Component c = null;

    /**
     * Constructor.
     *
     * @param s1
     * The new text for lStatus.
     *
     * @param s2
     * The new text for lCurrentFile.
     */
    public SetStateRunning2 (String s1, String s2, Component thec) {
      text1 = s1; text2 = s2; c = thec;
    }

    /**
     * Implementation of Runnable.
     */
    public void run() {
      lStatus.setForeground(cRed);
      lStatus.setText(text1);
      lCurrentFile.setText(text2);
      if(t1.mustPackAgain(lStatus) || t2.mustPackAgain(lCurrentFile)) {
        pack();
        ComponentPositioner.correctPosition(c);
      }
      repaint();
    }

  }



}



// vim: set ai sw=2 :
// project bmeps
// @(#)BmepsMainWindow.java 1.8 10/28/09

