.option use tool tip text as accessible description = yes
.default border		=	border
.default fill		=	none
.default anchor		=	west

border			=	border
fill			=	none
title			=	BGS.wt[1]
layout			=	box.line_axis
default close operation	=	hide
contents		=	pHorizontalSpacePanel

[JPanel pHorizontalSpacePanel]
layout			=	box.page_axis
contents		=	pMakeMode
contents		=	pOptions
contents		=	pButtons

[JTabbedPane pOptions]
contents		=	pPredefined	BGS.lt[11]
contents		=	pFullCustom	BGS.lt[12]

[JPanel pPredefined]
layout			=	gridbag
contents		=	rbBuiltinConfiguration	 0  0  1  1
contents		=	cbBuiltinConfiguration	+1  .  1  1
contents		=	rbFileConfiguration	 0 +1  1  1
contents		=	cbFileConfiguration	+1  .  1  1
border weight		=	0 0 1 1

[JRadioButton rbBuiltinConfiguration]
button group		=	rbgConfigurations
text			=	BGS.lt[13]
tool tip text		=	BGS.lt[53]
action command		=	BGS.ac[11]
action listener		=	this

[JComboBox cbBuiltinConfiguration]
tool tip text		=	BGS.lt[53]
constructor		=	bc.predefConf
size group		=	sgConf

[JRadioButton rbFileConfiguration]
button group		=	rbgConfigurations
text			=	BGS.lt[14]
tool tip text		=	BGS.lt[54]
action command		=	BGS.ac[12]
action listener		=	this

[JComboBox cbFileConfiguration]
constructor		=	bc.fileConf
size group		=	sgConf
tool tip text		=	BGS.lt[54]

[JPanel pFullCustom]
layout			=	gridbag
contents		=	lChooseBaseOutputFormat		 0  0  1  1
contents		=	cbChooseBaseOutputFormat	+1  .  1  1
contents		=	pDummy9				+1  .  1  1
contents		=	cbDraftMode			+1  .  1  1
contents		=	pFormatSpecificOptions		 0 +1  4  1
border weight		=	0 0 1 1

[JLabel lChooseBaseOutputFormat]
text			=	BGS.lt[15]

[JComboBox cbChooseBaseOutputFormat]
constructor		=	BGS.baseOutputFormats
item listener		=	this
tool tip text		=	BGS.lt[55]

[JPanel pDummy9]
minimum size		=	10 1
preferred size		=	15 1

[JCheckBox cbDraftMode]
text			=	BGS.lt[98]
tool tip text		=	BGS.lt[99]
item listener		=	this

[JPanel pFormatSpecificOptions]
layout			=	card
fill			=	both
contents		=	pFormatSpecificPostscript	BGS.baseOutputFormats[0]
contents		=	pFormatSpecificPdf		BGS.baseOutputFormats[1]
contents		=	pFormatSpecificBoundingBox	BGS.baseOutputFormats[2]

[JPanel pFormatSpecificPostscript]
component border	=	titled BGS.lt[16]
layout			=	gridbag
contents		=	pSpecPs1	 0  0  1  1
contents		=	pSpecPs2	+1  .  1  1
contents		=	pSpecPs3	 0 +1  1  1
contents		=	pSpecPs4	+1  .  1  1
contents		=	pSpecPs5	 0 +1  2  1
border weight		=	0 0 1 1

[JPanel pSpecPs1]
fill			=	both
component border	=	titled BGS.lt[24]
layout			=	gridbag
contents		=	lPsVersion	 0  0  1  1
contents		=	cbPsVersion	+1  .  1  1
contents		=	pDummy3		+1  .  1  1
contents		=	cbPsEncaps	+1  .  1  1
contents		=	cbPsDsc		 0 +1  2  1
contents		=	cbPsColor	+3  .  1  1
contents		=	cbPsInterpol	 0 +1  2  1
contents		=	cbPsIntJpeg	+3  .  1  1
border weight		=	0 0 1 1

[JLabel lPsVersion]
text			=	BGS.lt[20]

[JComboBox cbPsVersion]
constructor		=	BGS.psFormatVersion
item listener		=	this
tool tip text		=	BGS.lt[56]

[JCheckBox cbPsEncaps]
text			=	BGS.lt[21]
item listener		=	this
tool tip text		=	BGS.lt[57]

[JCheckBox cbPsDsc]
text			=	BGS.lt[22]
tool tip text		=	BGS.lt[58]

[JCheckBox cbPsColor]
text			=	BGS.lt[23]
tool tip text		=	BGS.lt[59]

[JCheckBox cbPsInterpol]
text			=	BGS.lt[46]
item listener		=	this
tool tip text		=	BGS.lt[60]

[JPanel pDummy3]
minimum size		=	10 1
preferred size		=	15 1

[JCheckBox cbPsIntJpeg]
text			=	BGS.lt[47]
tool tip text		=	BGS.lt[61]

[JPanel pSpecPs2]
fill			=	both
component border	=	titled BGS.lt[25]
layout			=	gridbag
contents		=	cbAlphaPsMix			 0  0  3  1
contents		=	csaBackground			+3  .  1  1
contents		=	pDummy1				+1  .  1  1
contents		=	cbAlphaPsPreferDefault		+1  .  1  1
# contents		=	lAlphaPsDefaultBackground
contents		=	cbAlphaPsMask			 0 +1  2  1
contents		=	cbAlphaPsMaskLevel		+2  .  4  1
# ##### Alpha channel
border weight		=	0 0 1 1

[JCheckBox cbAlphaPsMix]
text			=	BGS.lt[33]
item listener		=	this
tool tip text		=	BGS.lt[62]

[JPanel pDummy1]
minimum size		=	10 1
preferred size		=	15 1

# [JLabel lAlphaPsDefaultBackground]
# text			=	BGS.lt[34]

[ColorShowArea csaBackground]
minimum size		=	10 10
preferred size		=	15 15
tool tip text		=	BGS.lt[63]
action command		=	BGS.ac[13]
action listener		=	this

[JCheckBox cbAlphaPsPreferDefault]
text			=	BGS.lt[35]
tool tip text		=	BGS.lt[64]

[JCheckBox cbAlphaPsMask]
text			=	BGS.lt[36]
item listener		=	this
tool tip text		=	BGS.lt[65]

[JComboBox cbAlphaPsMaskLevel]
constructor		=	BGS.maskAlphaLevel
item listener		=	this
tool tip text		=	BGS.lt[66]

[JPanel pSpecPs3]
fill			=	both
component border	=	titled BGS.lt[26]
layout			=	gridbag
contents		=	rbPsRes1	 0  0  2  1
contents		=	rbPsRes2	 0 +1  2  1
contents		=	rbPsRes3	 0 +1  1  1
contents		=	cbPsPaperSize	+1  .  1  1
border weight		=	0 0 1 1

[JRadioButton rbPsRes1]
text			=	BGS.lt[30]
button group		=	rbgPsRes
tool tip text		=	BGS.lt[67]

[JRadioButton rbPsRes2]
text			=	BGS.lt[31]
button group		=	rbgPsRes
tool tip text		=	BGS.lt[68]

[JRadioButton rbPsRes3]
text			=	BGS.lt[32]
button group		=	rbgPsRes
tool tip text		=	BGS.lt[69]

[JComboBox cbPsPaperSize]
constructor		=	BGS.paperSizes
tool tip text		=	BGS.lt[69]

[JPanel pSpecPs4]
fill			=	both
component border	=	titled BGS.lt[27]
layout			=	gridbag
contents		=	cbPsDictionary	 0  0  1  1
contents		=	cbPsVmreclaim	 0 +1  1  1
contents		=	cbPsShowpage	 0 +1  1  1
border weight		=	0 0 1 1

[JCheckBox cbPsDictionary]
text			=	BGS.lt[37]
item listener		=	this
tool tip text		=	BGS.lt[70]

[JCheckBox cbPsVmreclaim]
text			=	BGS.lt[38]
tool tip text		=	BGS.lt[71]

[JCheckBox cbPsShowpage]
text			=	BGS.lt[39]
tool tip text		=	BGS.lt[72]

[JPanel pSpecPs5]
fill			=	both
component border	=	titled BGS.lt[28]
layout			=	gridbag
contents		=	lPsBinary		 0  0  2  1
contents		=	cbPsBinary		+2  .  1  1
contents		=	cbPsRunLength		 0 +1  2  1
contents		=	cbPsMultipleDataSources +2  .  1  1
contents		=	cbPsFlate		 0 +1  3  1
contents		=	cbPsDct			 0 +1  3  1
contents		=	cbPsForceDct		 0 +1  3  1
contents		=	pDummy2			 0 +1  1  1
contents		=	lPsDct			+1  .  1  1
contents		=	pPsDctSofBox		+1  .  1  1
border weight		=	0 0 1 1

[JLabel lPsBinary]
text			=	BGS.lt[40]
tool tip text		=	BGS.lt[73]

[JComboBox cbPsBinary]
constructor		=	BGS.binaryDataHandling
tool tip text		=	BGS.lt[73]

[JCheckBox cbPsRunLength]
text			=	BGS.lt[41]
item listener		=	this
tool tip text		=	BGS.lt[74]

[JPanel pDummy2]
minimum size		=	10 1
preferred size		=	15 1

[JCheckBox cbPsMultipleDataSources]
text			=	BGS.lt[42]
tool tip text		=	BGS.lt[75]

[JCheckBox cbPsFlate]
text			=	BGS.lt[43]
tool tip text		=	BGS.lt[76]

[JCheckBox cbPsDct]
text			=	BGS.lt[44]
item listener		=	this
vertical alignment	=	top
fill			=	vertical
tool tip text		=	BGS.lt[77]


[JCheckBox cbPsForceDct]
text			=	BGS.lt[107]
item listener		=	this
vertical alignment	=	top
fill			=	vertical
tool tip text		=	BGS.lt[108]

[JLabel lPsDct]
text			=	BGS.lt[45]
tool tip text		=	BGS.lt[78]

[JPanel pPsDctSofBox]
border			=	0
layout			=	box.x_axis
contents		=	pPsDctSof
contents		=	$glue

[JPanel pPsDctSof]
layout			=	gridbag
border			=	0
contents		=	cbPsDctSof00	  0  0  1  1
contents		=	cbPsDctSof01	  1  0  1  1
contents		=	cbPsDctSof02	  2  0  1  1
contents		=	cbPsDctSof03	  3  0  1  1
contents		=	cbPsDctSof04	  4  0  1  1
contents		=	cbPsDctSof05	  5  0  1  1
contents		=	cbPsDctSof06	  6  0  1  1
contents		=	cbPsDctSof07	  7  0  1  1
contents		=	cbPsDctSof08	  8  0  1  1
contents		=	cbPsDctSof09	  9  0  1  1
contents		=	cbPsDctSof10	 10  0  1  1
contents		=	cbPsDctSof11	 11  0  1  1
contents		=	cbPsDctSof12	 12  0  1  1
contents		=	cbPsDctSof13	 13  0  1  1
contents		=	cbPsDctSof14	 14  0  1  1
contents		=	cbPsDctSof15	 17  0  1  1
border weight		=	0 0 1 1

[JCheckBox cbPsDctSof00]
text			=	BGS.sofNumbers[0]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof01]
text			=	BGS.sofNumbers[1]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof02]
text			=	BGS.sofNumbers[2]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof03]
text			=	BGS.sofNumbers[3]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof04]
text			=	BGS.sofNumbers[4]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof05]
text			=	BGS.sofNumbers[5]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof06]
text			=	BGS.sofNumbers[6]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof07]
text			=	BGS.sofNumbers[7]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof08]
text			=	BGS.sofNumbers[8]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof09]
text			=	BGS.sofNumbers[9]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof10]
text			=	BGS.sofNumbers[10]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof11]
text			=	BGS.sofNumbers[11]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof12]
text			=	BGS.sofNumbers[12]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof13]
text			=	BGS.sofNumbers[13]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof14]
text			=	BGS.sofNumbers[14]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JCheckBox cbPsDctSof15]
text			=	BGS.sofNumbers[15]
size group		=	sgPsSofs
tool tip text		=	BGS.lt[78]

[JPanel pFormatSpecificPdf]
component border	=	titled BGS.lt[17]
layout			=	gridbag
contents		=	pSpecPdf1	 0  0  1  1
contents		=	pSpecPdf2	+1  .  1  2
contents		=	pSpecPdf3	 0 +1  1  1
contents		=	pSpecPdf4	 0 +1  2  1
border weight		=	0 0 1 1

[JPanel pSpecPdf1]
fill			=	both
component border	=	titled	BGS.lt[29]
layout			=	gridbag
contents		=	lPdfVersion		 0  0  1  1
contents		=	cbPdfVersion		+1  .  1  1
contents		=	pDummy4			+1  .  1  1
contents		=	lPdfFit			+1  .  1  1
contents		=	cbPdfFit		+1  .  1  1
contents		=	cbPdfInterpol		 0 +1  2  1
contents		=	cbPdfInterpolJpeg	 3  .  2  1
border weight		=	0 0 1 1

[JLabel lPdfVersion]
text			=	BGS.lt[48]
tool tip text		=	BGS.lt[79]

[JComboBox cbPdfVersion]
constructor		=	BGS.pdfFormatVersion
size group		=	sgPdfGeneral
item listener		=	this
tool tip text		=	BGS.lt[79]

[JLabel lPdfFit]
text			=	BGS.lt[49]
tool tip text		=	BGS.lt[80]

[JComboBox cbPdfFit]
constructor		=	BGS.pdfFitAtOpen
size group		=	sgPdfGeneral
tool tip text		=	BGS.lt[80]

[JCheckBox cbPdfInterpol]
text			=	BGS.lt[46]
item listener		=	this
tool tip text		=	BGS.lt[60]

[JPanel pDummy4]
minimum size		=	10 1
preferred size		=	15 1

[JCheckBox cbPdfInterpolJpeg]
text			=	BGS.lt[47]
tool tip text		=	BGS.lt[61]


[JPanel pSpecPdf2]
fill			=	both
component border	=	titled BGS.lt[25]
layout			=	gridbag
contents		=	cbPdfTransferAlpha	 0  0  5  1
contents		=	pDummy6			 0 +1  1  1
contents		=	cbPdfPageAttributes	+1  .  4  1
contents		=	cbPdfAlphaMix		 0 +1  2  1
contents		=	csaPdfAlphaBg		+2  .  1  1
contents		=	pDummy5			+1  .  1  1
contents		=	cbPdfAlphaBg		+1  .  1  1
contents		=	cbPdfAlphaMask		 0 +1  2  1
contents		=	cbPdfAlphaMaskTrigger	+2  .  3  1
border weight		=	0 0 1 1

[JCheckBox cbPdfTransferAlpha]
text			=	BGS.lt[50]
item listener		=	this
tool tip text		=	BGS.lt[81]

[JPanel pDummy6]
minimum size		=	10 1
preferred size		=	15 1

[JCheckBox cbPdfPageAttributes]
text			=	BGS.lt[94]
tool tip text		=	BGS.lt[95]

[JCheckBox cbPdfAlphaMix]
text			=	BGS.lt[33]
item listener		=	this
tool tip text		=	BGS.lt[62]

# [JLabel lPdfAlphaBg]
# text			=	BGS.lt[34]

[ColorShowArea csaPdfAlphaBg]
minimum size		=	10 10
preferred size		=	15 15
tool tip text		=	BGS.lt[63]
action command		=	BGS.ac[14]
action listener		=	this

[JPanel pDummy5]
minimum size		=	10 10
preferred size		=	15 15

[JCheckBox cbPdfAlphaBg]
text			=	BGS.lt[35]
tool tip text		=	BGS.lt[64]

[JCheckBox cbPdfAlphaMask]
text			=	BGS.lt[36]
item listener		=	this
tool tip text		=	BGS.lt[65]

[JComboBox cbPdfAlphaMaskTrigger]
constructor		=	BGS.maskAlphaLevel
tool tip text		=	BGS.lt[66]

[JPanel pSpecPdf3]
fill			=	both
component border	=	titled BGS.lt[26]
layout			=	gridbag
contents		=	rbPdfSizePixPoint		 0  0  2  1
contents		=	rbPdfSizeResolutionChunk	 0 +1  2  1
contents		=	rbPdfSizeFitPaper		 0 +1  1  1
contents		=	cbPdfSizePaperSize		+1  .  1  1
border weight		=	0 0 1 1

[JRadioButton rbPdfSizePixPoint]
button group		=	bgPdfSize
text			=	BGS.lt[30]
tool tip text		=	BGS.lt[67]

[JRadioButton rbPdfSizeResolutionChunk]
button group		=	bgPdfSize
text			=	BGS.lt[31]
tool tip text		=	BGS.lt[68]

[JRadioButton rbPdfSizeFitPaper]
button group		=	bgPdfSize
text			=	BGS.lt[32]
tool tip text		=	BGS.lt[69]

[JComboBox cbPdfSizePaperSize]
constructor		=	BGS.paperSizes
tool tip text		=	BGS.lt[69]

[JPanel pSpecPdf4]
fill			=	both
component border	=	titled BGS.lt[109]
layout			=	gridbag
contents		=	cbPdfForceDct	0  0 1 1
contents		=	pSpecPdf5	. +1 1 1

[JCheckBox cbPdfForceDct]
text			=	BGS.lt[110]
tool tip text		=	BGS.lt[111]
item listener		=	this

[JPanel pSpecPdf5]
fill			=	both
component border	=	titled BGS.lt[51]
layout			=	gridbag
contents		=	cbPdfDctSof00	0 0 1 1
contents		=	cbPdfDctSof01	1 0 1 1
contents		=	cbPdfDctSof02	2 0 1 1
contents		=	cbPdfDctSof03	3 0 1 1
contents		=	cbPdfDctSof04	4 0 1 1
contents		=	cbPdfDctSof05	5 0 1 1
contents		=	cbPdfDctSof06	6 0 1 1
contents		=	cbPdfDctSof07	7 0 1 1
contents		=	cbPdfDctSof08	8 0 1 1
contents		=	cbPdfDctSof09	9 0 1 1
contents		=	cbPdfDctSof10	10 0 1 1
contents		=	cbPdfDctSof11	11 0 1 1
contents		=	cbPdfDctSof12	12 0 1 1
contents		=	cbPdfDctSof13	13 0 1 1
contents		=	cbPdfDctSof14	14 0 1 1
contents		=	cbPdfDctSof15	15 0 1 1
border weight		=	0 0 1 1

[JCheckBox cbPdfDctSof00]
text			=	BGS.sofNumbers[0]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof01]
text			=	BGS.sofNumbers[1]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof02]
text			=	BGS.sofNumbers[2]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof03]
text			=	BGS.sofNumbers[3]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof04]
text			=	BGS.sofNumbers[4]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof05]
text			=	BGS.sofNumbers[5]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof06]
text			=	BGS.sofNumbers[6]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof07]
text			=	BGS.sofNumbers[7]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof08]
text			=	BGS.sofNumbers[8]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof09]
text			=	BGS.sofNumbers[9]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof10]
text			=	BGS.sofNumbers[10]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof11]
text			=	BGS.sofNumbers[11]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof12]
text			=	BGS.sofNumbers[12]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof13]
text			=	BGS.sofNumbers[13]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof14]
text			=	BGS.sofNumbers[14]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JCheckBox cbPdfDctSof15]
text			=	BGS.sofNumbers[15]
size group		=	sgPdfSof
tool tip text		=	BGS.lt[78]

[JPanel pFormatSpecificBoundingBox]
component border	=	titled BGS.lt[18]
layout			=	border
contents		=	lNoOptionsForBb			center

[JLabel lNoOptionsForBb]
text			=	BGS.lt[19]
fill			=	both
horizontal alignment	=	center
vertical alignment	=	Center

[JPanel pMakeMode]
layout			=	gridbag
component border	=	titled BGS.lt[52]
contents		=	cbMakeMode	 0  0  1  1
contents		=	pDummy7		+1  .  1  1
contents		=	cbLogAlways	+1  .  1  1
contents		=	pDummy8		+1  .  1  1
border weight		=	0 0 1 1

[JCheckBox cbMakeMode]
text			=	BGS.lt[34]
tool tip text		=	BGS.lt[82]

[JPanel pDummy7]
minimum size		=	10 1
preferred size		=	15 1

[JCheckBox cbLogAlways]
text			=	BGS.lt[96]
tool tip text		=	BGS.lt[97]

[JPanel pDummy8]
minimum size		=	10 1
preferred size		=	15 1
fill			=	horizontal

[JPanel pButtons]
layout			=	box.line_axis
contents		=	$glue
contents		=	bOK
contents		=	bCancel
contents		=	bReset
contents		=	bDefaults
contents		=	$glue

[JButton bOK]
text			=	BGS.ac[7]
action listener		=	this
size group		=	sgButtons
tool tip text		=	BGS.lt[83]

[JButton bCancel]
text			=	BGS.ac[8]
action listener		=	this
size group		=	sgButtons
tool tip text		=	BGS.lt[84]

[JButton bReset]
text			=	BGS.ac[9]
action listener		=	this
size group		=	sgButtons
tool tip text		=	BGS.lt[85]

[JButton bDefaults]
text			=	BGS.ac[10]
action listener		=	this
size group		=	sgButtons
tool tip text		=	BGS.lt[86]




# project bmeps
# @(#)BmepsOptionsDialog.jl 1.6 10/28/09
# vim : set ai sw=2 :

