


sub create_toc_and_text($$) {
  my $srcname = shift;
  my $baseind = shift;
  my $line;
  my $command;
  my $label;
  my $text;
  my $aref; my $ln;
  my $qref = undef;	# array ref (ref@lines, $lineno)
  my @objects;		# contains objects ($command, $label, $text, $ref)
  my $objno = -1;	# number of final object
  my $i;		# to traverse array of objects
  my $io;		# current object
  my $ioco;		# current objects command
  my $iola;		# current objects label
  my $iote;		# current objects text
  my $iota;		# lines array for current object
  my $ioli;		# line number in current object
  my $ind;		# indentation level
  my $j;		# running index to insert spaces
  my $havehone = 0;	# flag: we already head a h3
  if(open(INPUT, "<$srcname")) {
    while(<INPUT>) {
      $line = $_; chomp $line;
      if($line =~ /^\s*\.\s*([123456])\s+(\S.*)/o) {
        $command = $1; $text = $2; $label = undef; $qref = undef;
	if($text =~/@([^\]]*)@\s*(\S.*)/o) {
	  $label = $1; $text = $2;
	}
	{
	  my @newobject = ($command, $label, $text, undef);
	  my @linesinquestion;
	  my @newquestion = (\@linesinquestion, -1);
	  $qref = \@newquestion;
	  $newobject[3] = $qref;
	  $objno++;
	  $objects[$objno] = \@newobject;
	}
      } else {
        if($line !~ /^\s*$/o) {
	  if(defined($qref)) {	# one more answer line for question
	    $aref = $qref->[0];
	    $ln = $qref->[1];
	    $ln++;
	    $aref->[$ln] = $line;
	    $qref->[1] = $ln;
	  } else {
	    # ##### ERROR
	  }
	}
      }
    }
    close(INPUT);
    # annotate (create labels if necessary)
    for($i = 0; $i <= $objno; $i++) {
      $io = $objects[$i];
      if(!defined($io->[1])) {
        $io->[1] = "l" . $i;
      }
    }
    # create table of contents
    print "<p>\n<ul class=\"tocul\">\n";
    for($i = 0; $i <= $objno; $i++) {
      $io = $objects[$i];
      $ioco = $io->[0];
      $iola = $io->[1];
      $iote = $io->[2];
      $qref = $io->[3];
      $iota = undef;
      $ioli = -1;
      if(defined($qref)) {
        $iota = $qref->[0]; $ioli = $qref->[1];
      }
      $ind = 6;
      if($ioco =~/[123456]/o) {
        $ind = $ioco - 1;
      }
      print "<li class=\"tocli\">";
      for($j = 0; $j < $ind; $j++) {
        print "&nbsp;&nbsp;";
      }
      print "<a class=\"toca\" href=\"#" . $iola . "\">";
      print "$iote";
      print "</a>";
      print "</li>\n";
    }
    print "</ul>\n</p>\n";
    # write output
    for($i = 0; $i <= $objno; $i++) {
      $io = $objects[$i];
      $ioco = $io->[0];
      $iola = $io->[1];
      $iote = $io->[2];
      $qref = $io->[3];
      $iota = undef;
      $ioli = -1;
      if(defined($qref)) {
        $iota = $qref->[0]; $ioli = $qref->[1];
      }
      if($ioco =~ /([123456])/o) {	# header
        $ind = $1; $ind = $ind + $baseind;
	if($ind == ($baseind + 1)) {
	  if($havehone) {
	    print "<hr>\n";
	  }
	  $havehone = 1;
	}
	$ind = "h$ind";
        print "<a name=\"" . $iola . "\">";
	print "<$ind>";
	print "$iote";
	print "</$ind>";
	print "</a>\n";
	if(defined($iota)) {
	  if($ioli > -1) {
	    for($j = 0; $j <= $ioli; $j++) {
	      print $iota->[$j] . "\n";
	    }
	  }
	}
      } else {	# ##### ERROR
      }
    }
  }
}

create_toc_and_text("install.txt", 2);

